#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * SwAvatarIface:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SwAvatarIface SwAvatarIface;

/**
 * SwAvatarIfaceClass:
 *
 * The class of SwAvatarIface.
 */
typedef struct _SwAvatarIfaceClass SwAvatarIfaceClass;

GType sw_avatar_iface_get_type (void);
#define SW_TYPE_AVATAR_IFACE \
  (sw_avatar_iface_get_type ())
#define SW_AVATAR_IFACE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SW_TYPE_AVATAR_IFACE, SwAvatarIface))
#define SW_IS_AVATAR_IFACE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SW_TYPE_AVATAR_IFACE))
#define SW_AVATAR_IFACE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SW_TYPE_AVATAR_IFACE, SwAvatarIfaceClass))


typedef void (*sw_avatar_iface_request_avatar_impl) (SwAvatarIface *self,
    DBusGMethodInvocation *context);
void sw_avatar_iface_implement_request_avatar (SwAvatarIfaceClass *klass, sw_avatar_iface_request_avatar_impl impl);
/**
 * sw_avatar_iface_return_from_request_avatar:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sw_avatar_iface_return_from_request_avatar (DBusGMethodInvocation *context);
static inline void
sw_avatar_iface_return_from_request_avatar (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void sw_avatar_iface_emit_avatar_retrieved (gpointer instance,
    const gchar *arg_path);


G_END_DECLS
