#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * SwBanishableIface:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SwBanishableIface SwBanishableIface;

/**
 * SwBanishableIfaceClass:
 *
 * The class of SwBanishableIface.
 */
typedef struct _SwBanishableIfaceClass SwBanishableIfaceClass;

GType sw_banishable_iface_get_type (void);
#define SW_TYPE_BANISHABLE_IFACE \
  (sw_banishable_iface_get_type ())
#define SW_BANISHABLE_IFACE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SW_TYPE_BANISHABLE_IFACE, SwBanishableIface))
#define SW_IS_BANISHABLE_IFACE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SW_TYPE_BANISHABLE_IFACE))
#define SW_BANISHABLE_IFACE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SW_TYPE_BANISHABLE_IFACE, SwBanishableIfaceClass))


typedef void (*sw_banishable_iface_hide_item_impl) (SwBanishableIface *self,
    const gchar *in_uid,
    DBusGMethodInvocation *context);
void sw_banishable_iface_implement_hide_item (SwBanishableIfaceClass *klass, sw_banishable_iface_hide_item_impl impl);
/**
 * sw_banishable_iface_return_from_hide_item:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sw_banishable_iface_return_from_hide_item (DBusGMethodInvocation *context);
static inline void
sw_banishable_iface_return_from_hide_item (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void sw_banishable_iface_emit_item_hidden (gpointer instance,
    const gchar *arg_uid);


G_END_DECLS
