#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * SwQueryIface:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SwQueryIface SwQueryIface;

/**
 * SwQueryIfaceClass:
 *
 * The class of SwQueryIface.
 */
typedef struct _SwQueryIfaceClass SwQueryIfaceClass;

GType sw_query_iface_get_type (void);
#define SW_TYPE_QUERY_IFACE \
  (sw_query_iface_get_type ())
#define SW_QUERY_IFACE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SW_TYPE_QUERY_IFACE, SwQueryIface))
#define SW_IS_QUERY_IFACE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SW_TYPE_QUERY_IFACE))
#define SW_QUERY_IFACE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SW_TYPE_QUERY_IFACE, SwQueryIfaceClass))


typedef void (*sw_query_iface_open_view_impl) (SwQueryIface *self,
    const gchar *in_query,
    GHashTable *in_params,
    DBusGMethodInvocation *context);
void sw_query_iface_implement_open_view (SwQueryIfaceClass *klass, sw_query_iface_open_view_impl impl);
/**
 * sw_query_iface_return_from_open_view:
 * @context: The D-Bus method invocation context
 * @out_view: const gchar * (FIXME, generate documentation)
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sw_query_iface_return_from_open_view (DBusGMethodInvocation *context,
    const gchar *out_view);
static inline void
sw_query_iface_return_from_open_view (DBusGMethodInvocation *context,
    const gchar *out_view)
{
  dbus_g_method_return (context,
      out_view);
}



G_END_DECLS
