#include <glib-object.h>
#include <dbus/dbus-glib.h>

G_BEGIN_DECLS

/**
 * SwStatusUpdateIface:
 *
 * Dummy typedef representing any implementation of this interface.
 */
typedef struct _SwStatusUpdateIface SwStatusUpdateIface;

/**
 * SwStatusUpdateIfaceClass:
 *
 * The class of SwStatusUpdateIface.
 */
typedef struct _SwStatusUpdateIfaceClass SwStatusUpdateIfaceClass;

GType sw_status_update_iface_get_type (void);
#define SW_TYPE_STATUS_UPDATE_IFACE \
  (sw_status_update_iface_get_type ())
#define SW_STATUS_UPDATE_IFACE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST((obj), SW_TYPE_STATUS_UPDATE_IFACE, SwStatusUpdateIface))
#define SW_IS_STATUS_UPDATE_IFACE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE((obj), SW_TYPE_STATUS_UPDATE_IFACE))
#define SW_STATUS_UPDATE_IFACE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_INTERFACE((obj), SW_TYPE_STATUS_UPDATE_IFACE, SwStatusUpdateIfaceClass))


typedef void (*sw_status_update_iface_update_status_impl) (SwStatusUpdateIface *self,
    const gchar *in_status_message,
    GHashTable *in_fields,
    DBusGMethodInvocation *context);
void sw_status_update_iface_implement_update_status (SwStatusUpdateIfaceClass *klass, sw_status_update_iface_update_status_impl impl);
/**
 * sw_status_update_iface_return_from_update_status:
 * @context: The D-Bus method invocation context
 *
 * Return successfully by calling dbus_g_method_return().
 * This inline function exists only to provide type-safety.
 */
static inline
/* this comment is to stop gtkdoc realising this is static */
void sw_status_update_iface_return_from_update_status (DBusGMethodInvocation *context);
static inline void
sw_status_update_iface_return_from_update_status (DBusGMethodInvocation *context)
{
  dbus_g_method_return (context);
}

void sw_status_update_iface_emit_status_updated (gpointer instance,
    gboolean arg_success);


G_END_DECLS
